﻿using ProjectAircraftCarrier.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectAircraftCarrier.CollectionGenericObjects;

public class WarshipDockService : AbstractCompany
{
    public WarshipDockService(int picWidth, int picHeight, ICollectionGenericObjects<DrawningWarship> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackground(Graphics g)
    {
        //рисуем доки
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i < width; i++)
        {
            for(int j = 0; j < height + 1; ++j)
            {
                g.DrawLine(pen, i * _placeSizeWidth, j * _placeSizeHeight, i * _placeSizeWidth + _placeSizeWidth / 2, j * _placeSizeHeight);            
            }
            g.DrawLine(pen, i * _placeSizeWidth, 0, i * _placeSizeWidth, _pictureHeight / _placeSizeHeight * _placeSizeHeight);
        }
    }

    protected override void SetObjectPosition()
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;

        int posWidth = 0;
        int posHeight = height - 1;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (_collection.Get(i) != null)
            {
                _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                _collection.Get(i).SetPosition(_placeSizeWidth * posWidth + 5, posHeight * _placeSizeHeight + 10);
            }
            if (posWidth < width - 1)
            {
                posWidth++;
            }
            else
            {
                posWidth = 0;
                posHeight--;
            }
            if (posHeight > height)
            {
                return;
            }
        }
    }
}
